{"openapi":"3.1.0","info":{"title":"Trellis","description":"Trellis is the fastest way to automate your document workflows","version":"1.0.0"},"paths":{"/v1/projects":{"get":{"tags":["project","public"],"summary":"Get Projects","description":"Retrieve a list of projects.\n\nParameters:\n- proj_ids (list[str], optional): A list of project ids. If not provided, all projects will be retrieved.\n\nReturns:\n- dict: A dict containing the status message and the list of project names.","operationId":"get_projects_v1_projects_get","parameters":[{"description":"A list of project ids","required":false,"schema":{"items":{"type":"string"},"type":"array","title":"Proj Ids","description":"A list of project ids"},"name":"proj_ids","in":"query"},{"description":"Search term","required":false,"schema":{"type":"string","title":"Search Term","description":"Search term"},"name":"search_term","in":"query"},{"required":false,"schema":{"type":"integer","exclusiveMinimum":true,"title":"Limit","default":20,"minimum":0.0},"name":"limit","in":"query"},{"required":false,"schema":{"type":"integer","minimum":0.0,"title":"Offset","default":0},"name":"offset","in":"query"},{"required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/OrderByEnum"}],"default":"updated_at"},"name":"order_by","in":"query"},{"required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/SortOrderEnum"}],"default":"desc"},"name":"order","in":"query"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetProjectsResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"project_not_found":{"summary":"project_not_found","value":{"request_id":"$request_id","error":{"code":"project_not_found","message":"Project not found with id(s): $project_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_not_found":{"summary":"transform_not_found","value":{"request_id":"$request_id","error":{"code":"transform_not_found","message":"Transform not found with id(s): $transform_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"template_transform_not_found":{"summary":"template_transform_not_found","value":{"request_id":"$request_id","error":{"code":"template_transform_not_found","message":"Transform not found with id(s): $transform_ids. Project id: $project_ids, Template id: $template_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"bad_request":{"summary":"bad_request","value":{"request_id":"$request_id","error":{"code":"bad_request","message":"$message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/projects/{proj_id}":{"delete":{"tags":["project","public"],"summary":"Delete Project","description":"Delete a project.\n\nParameters:\n- proj_id (str): The id of the project.","operationId":"delete_project_v1_projects__proj_id__delete","parameters":[{"required":true,"schema":{"type":"string","title":"Proj Id"},"name":"proj_id","in":"path"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeleteProjectResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"project_not_found":{"summary":"project_not_found","value":{"request_id":"$request_id","error":{"code":"project_not_found","message":"Project not found with id(s): $project_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_not_found":{"summary":"transform_not_found","value":{"request_id":"$request_id","error":{"code":"transform_not_found","message":"Transform not found with id(s): $transform_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"template_transform_not_found":{"summary":"template_transform_not_found","value":{"request_id":"$request_id","error":{"code":"template_transform_not_found","message":"Transform not found with id(s): $transform_ids. Project id: $project_ids, Template id: $template_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"bad_request":{"summary":"bad_request","value":{"request_id":"$request_id","error":{"code":"bad_request","message":"$message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/projects/create":{"post":{"tags":["project","public"],"summary":"Create Project","description":"Create a new project.\n\nArgs:\n    proj_name (str): The name of the project.","operationId":"create_project_v1_projects_create_post","parameters":[{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateProjectRequestBody"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateProjectResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"project_not_found":{"summary":"project_not_found","value":{"request_id":"$request_id","error":{"code":"project_not_found","message":"Project not found with id(s): $project_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_not_found":{"summary":"transform_not_found","value":{"request_id":"$request_id","error":{"code":"transform_not_found","message":"Transform not found with id(s): $transform_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"template_transform_not_found":{"summary":"template_transform_not_found","value":{"request_id":"$request_id","error":{"code":"template_transform_not_found","message":"Transform not found with id(s): $transform_ids. Project id: $project_ids, Template id: $template_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"bad_request":{"summary":"bad_request","value":{"request_id":"$request_id","error":{"code":"bad_request","message":"$message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/assets/presigned":{"post":{"tags":["assets","public"],"summary":"Create Presigned Urls","description":"Creates presigned URLs for uploading files associated with specific IDs.\n\nThis endpoint allows you to upload up to 20 files and associate each with an ID. It returns presigned URLs for uploading the files directly to the storage service.\n\n**Parameters**\n\n- **files** (*List[UploadFile]*): List of files to be uploaded (maximum of 20 files).\n- **ids** (*List[str]*): List of IDs associated with the files.\n\n**Returns**\n\n`Dict`: A dictionary containing a message and a list of dictionaries mapping each ID to its presigned URL.\n\n**Example Response**\n\n```json\n{\n    \"message\": \"Files uploaded successfully.\",\n    \"presigned_urls\": [\n        {\n            \"id1\": \"https://s3.amazonaws.com/your-bucket/tmp_filename1\"\n        },\n        {\n            \"id2\": \"https://s3.amazonaws.com/your-bucket/tmp_filename2\"\n        }\n    ]\n}\n```","operationId":"create_presigned_urls_v1_assets_presigned_post","parameters":[{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"multipart/form-data":{"schema":{"$ref":"#/components/schemas/Body_create_presigned_urls_v1_assets_presigned_post"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"type":"object","title":"Response Create Presigned Urls V1 Assets Presigned Post"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"asset_not_found":{"summary":"asset_not_found","value":{"request_id":"$request_id","error":{"code":"asset_not_found","message":"Asset not found with id(s): $asset_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"asset_not_found_on_row":{"summary":"asset_not_found_on_row","value":{"request_id":"$request_id","error":{"code":"asset_not_found_on_row","message":"Asset not found on row with id(s): $row_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"asset_extraction_timeout":{"summary":"asset_extraction_timeout","value":{"request_id":"$request_id","error":{"code":"asset_extraction_timeout","message":"Timeout waiting for asset extraction results. Max timeout is 120 seconds","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"invalid_id_count":{"summary":"invalid_id_count","value":{"request_id":"$request_id","error":{"code":"invalid_id_count","message":"The number of files must match the number of IDs","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"maxmium_files_exceeded":{"summary":"maxmium_files_exceeded","value":{"request_id":"$request_id","error":{"code":"maxmium_files_exceeded","message":"Max 20 files can be processed at once.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]},{"APIKeyHeader":[]}]}},"/v1/assets/upload":{"post":{"tags":["assets","public"],"summary":"Upload Assets","operationId":"upload_assets_v1_assets_upload_post","parameters":[{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UploadAssetRequestBody"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AssetsResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"asset_not_found":{"summary":"asset_not_found","value":{"request_id":"$request_id","error":{"code":"asset_not_found","message":"Asset not found with id(s): $asset_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"asset_not_found_on_row":{"summary":"asset_not_found_on_row","value":{"request_id":"$request_id","error":{"code":"asset_not_found_on_row","message":"Asset not found on row with id(s): $row_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"asset_extraction_timeout":{"summary":"asset_extraction_timeout","value":{"request_id":"$request_id","error":{"code":"asset_extraction_timeout","message":"Timeout waiting for asset extraction results. Max timeout is 120 seconds","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"cells_assets_mismatch":{"summary":"cells_assets_mismatch","value":{"request_id":"$request_id","error":{"code":"cells_assets_mismatch","message":"The number of provided asset urls and cells are not the same.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"add_asset_to_nonasset_column":{"summary":"add_asset_to_nonasset_column","value":{"request_id":"$request_id","error":{"code":"add_asset_to_nonasset_column","message":"Attempted to add an asset to field $field_id of type $column_type, forbidden","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"invalid_asset_status":{"summary":"invalid_asset_status","value":{"request_id":"$request_id","error":{"code":"invalid_asset_status","message":"Invalid asset statuses provided: $asset_statuses.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"assets_not_processed":{"summary":"assets_not_processed","value":{"request_id":"$request_id","error":{"code":"assets_not_processed","message":"Requested assets are not processed yet.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"assets_dont_belong_to_transform":{"summary":"assets_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"assets_dont_belong_to_transform","message":"The asset ids $asset_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]},{"APIKeyHeader":[]}]}},"/v1/assets":{"get":{"tags":["assets","public"],"summary":"Get Assets","description":"Retrieve asset IDs from a project.\n\nParameters:\n- asset_ids (List[str], optional): The list of asset IDs to retrieve. This is optional, but will override the proj_id if provided.\n- proj_id (str, optional): The id of the project. This is optional, but will be used if asset_ids is not provided.\n- status (AssetStatus, optional): Filters the results based on the status of the assets.\n- limit (int, optional): The number of transformations to retrieve.\n- offset (int, optional): The offset to start retrieving transformations from.\n- order_by (str, optional): The column to order the transformations by.\n- order (str, optional): The order to sort the transformations by.\n\nIf neither asset_ids or proj_id is provided, all assets will be retrieved.\n\nReturns:\n- dict: A dict containing the all the asset data.","operationId":"get_assets_v1_assets_get","parameters":[{"description":"List of asset IDs to retrieve.","required":false,"schema":{"items":{"type":"string"},"type":"array","title":"Asset Ids","description":"List of asset IDs to retrieve."},"name":"asset_ids","in":"query"},{"description":"The id of the project.","required":false,"schema":{"type":"string","title":"Proj Id","description":"The id of the project."},"name":"proj_id","in":"query"},{"description":"The id of the transformation.","required":false,"schema":{"type":"string","title":"Transform Id","description":"The id of the transformation."},"name":"transform_id","in":"query"},{"description":"Row ID where the asset belongs","required":false,"schema":{"type":"string","title":"Row Id","description":"Row ID where the asset belongs"},"name":"row_id","in":"query"},{"description":"Operation ID where the asset belongs","required":false,"schema":{"type":"string","title":"Operation Id","description":"Operation ID where the asset belongs"},"name":"operation_id","in":"query"},{"description":"Entity ID where the asset belongs","required":false,"schema":{"type":"string","title":"Entity Id","description":"Entity ID where the asset belongs"},"name":"entity_id","in":"query"},{"description":"Entity field ID where the asset belongs","required":false,"schema":{"type":"string","title":"Entity Field Id","description":"Entity field ID where the asset belongs"},"name":"entity_field_id","in":"query"},{"description":"The status of the assets to retrieve.","required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/AssetStatus"}],"description":"The status of the assets to retrieve."},"name":"status","in":"query"},{"required":false,"schema":{"type":"integer","exclusiveMinimum":true,"title":"Limit","default":20,"minimum":0.0},"name":"limit","in":"query"},{"required":false,"schema":{"type":"integer","minimum":0.0,"title":"Offset","default":0},"name":"offset","in":"query"},{"required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/OrderByEnum"}],"default":"updated_at"},"name":"order_by","in":"query"},{"required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/SortOrderEnum"}],"default":"desc"},"name":"order","in":"query"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AssetsResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"asset_not_found":{"summary":"asset_not_found","value":{"request_id":"$request_id","error":{"code":"asset_not_found","message":"Asset not found with id(s): $asset_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"asset_not_found_on_row":{"summary":"asset_not_found_on_row","value":{"request_id":"$request_id","error":{"code":"asset_not_found_on_row","message":"Asset not found on row with id(s): $row_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"asset_extraction_timeout":{"summary":"asset_extraction_timeout","value":{"request_id":"$request_id","error":{"code":"asset_extraction_timeout","message":"Timeout waiting for asset extraction results. Max timeout is 120 seconds","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"cells_assets_mismatch":{"summary":"cells_assets_mismatch","value":{"request_id":"$request_id","error":{"code":"cells_assets_mismatch","message":"The number of provided asset urls and cells are not the same.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"add_asset_to_nonasset_column":{"summary":"add_asset_to_nonasset_column","value":{"request_id":"$request_id","error":{"code":"add_asset_to_nonasset_column","message":"Attempted to add an asset to field $field_id of type $column_type, forbidden","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"invalid_asset_status":{"summary":"invalid_asset_status","value":{"request_id":"$request_id","error":{"code":"invalid_asset_status","message":"Invalid asset statuses provided: $asset_statuses.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"assets_not_processed":{"summary":"assets_not_processed","value":{"request_id":"$request_id","error":{"code":"assets_not_processed","message":"Requested assets are not processed yet.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"assets_dont_belong_to_transform":{"summary":"assets_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"assets_dont_belong_to_transform","message":"The asset ids $asset_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]},{"APIKeyHeader":[]}]}},"/v1/assets/{asset_id}":{"delete":{"tags":["assets","public"],"summary":"Delete Assets","description":"Delete an asset from the project.\n\nParameters:\n- asset_id (str): The asset ID to delete.\nReturns:\n- bool: A boolean indicating if the asset was deleted successfully.","operationId":"delete_assets_v1_assets__asset_id__delete","parameters":[{"required":true,"schema":{"type":"string","title":"Asset Id"},"name":"asset_id","in":"path"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeleteAssetResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"asset_not_found":{"summary":"asset_not_found","value":{"request_id":"$request_id","error":{"code":"asset_not_found","message":"Asset not found with id(s): $asset_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"asset_not_found_on_row":{"summary":"asset_not_found_on_row","value":{"request_id":"$request_id","error":{"code":"asset_not_found_on_row","message":"Asset not found on row with id(s): $row_ids.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"asset_extraction_timeout":{"summary":"asset_extraction_timeout","value":{"request_id":"$request_id","error":{"code":"asset_extraction_timeout","message":"Timeout waiting for asset extraction results. Max timeout is 120 seconds","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"cells_assets_mismatch":{"summary":"cells_assets_mismatch","value":{"request_id":"$request_id","error":{"code":"cells_assets_mismatch","message":"The number of provided asset urls and cells are not the same.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"add_asset_to_nonasset_column":{"summary":"add_asset_to_nonasset_column","value":{"request_id":"$request_id","error":{"code":"add_asset_to_nonasset_column","message":"Attempted to add an asset to field $field_id of type $column_type, forbidden","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"invalid_asset_status":{"summary":"invalid_asset_status","value":{"request_id":"$request_id","error":{"code":"invalid_asset_status","message":"Invalid asset statuses provided: $asset_statuses.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"assets_not_processed":{"summary":"assets_not_processed","value":{"request_id":"$request_id","error":{"code":"assets_not_processed","message":"Requested assets are not processed yet.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"assets_dont_belong_to_transform":{"summary":"assets_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"assets_dont_belong_to_transform","message":"The asset ids $asset_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]},{"APIKeyHeader":[]}]}},"/v1/transforms/{transform_id}/rows/{row_id}/references":{"post":{"tags":["transforms","public"],"summary":"Retrieve Or Generate References On Row","description":"Retrieve or (if none exist) generate references for a given row.","operationId":"retrieve_or_generate_references_on_row_v1_transforms__transform_id__rows__row_id__references_post","parameters":[{"required":true,"schema":{"type":"string","title":"Transform Id"},"name":"transform_id","in":"path"},{"required":true,"schema":{"type":"string","title":"Row Id"},"name":"row_id","in":"path"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ReferencesOnRowResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"transformation_not_found":{"summary":"transformation_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_not_found","message":"Transformation not found with id(s): $transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"customer_not_found":{"summary":"customer_not_found","value":{"request_id":"$request_id","error":{"code":"customer_not_found","message":"Customer for transformation not found with id(s): $cust_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found":{"summary":"transformation_row_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found","message":"Transformation row not found with id(s): $transform_row_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found_for_asset":{"summary":"transformation_row_not_found_for_asset","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found_for_asset","message":"Transformation row not found with asset id(s): $transform_asset_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"no_asset_type_ops_found":{"summary":"no_asset_type_ops_found","value":{"request_id":"$request_id","error":{"code":"no_asset_type_ops_found","message":"At least one asset-type column is required to create a new transformation.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"not_all_column_column_ops":{"summary":"not_all_column_column_ops","value":{"request_id":"$request_id","error":{"code":"not_all_column_column_ops","message":"The following non-asset, non-manual operations don't reference other columns: $op_ids","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_not_completed":{"summary":"transformation_not_completed","value":{"request_id":"$request_id","error":{"code":"transformation_not_completed","message":"Transformation is not yet completed","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"no_transform_operations":{"summary":"no_transform_operations","value":{"request_id":"$request_id","error":{"code":"no_transform_operations","message":"No transformation operations found","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"failed_to_create_transform":{"summary":"failed_to_create_transform","value":{"request_id":"$request_id","error":{"code":"failed_to_create_transform","message":"Failed to create Transform","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_run_failed_to_start":{"summary":"transform_run_failed_to_start","value":{"request_id":"$request_id","error":{"code":"transform_run_failed_to_start","message":"Transformation run failed to start","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"rows_dont_belong_to_transform":{"summary":"rows_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"rows_dont_belong_to_transform","message":"The row ids $row_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/transforms":{"get":{"tags":["transforms","public"],"summary":"Get Transforms","description":"Retrieve all transformation associated with you.\n\nParameters:\n- transform_ids (list, optional): The IDs of the transformations to retrieve.\n- proj_ids (list, optional): The ids of the projects to retrieve transformations from.\n- include_params (bool, optional): Include metadata in the response such as the transform_params. Defaults to false.\n\nReturns:\n- dict: A dict containing all the transformations associated with you.","operationId":"get_transforms_v1_transforms_get","parameters":[{"description":"Search term to filter transformations against their id and name.","required":false,"schema":{"type":"string","title":"Search Term","description":"Search term to filter transformations against their id and name."},"name":"search_term","in":"query"},{"description":"List of transform IDs to retrieve.","required":false,"schema":{"items":{"type":"string"},"type":"array","title":"Transform Ids","description":"List of transform IDs to retrieve."},"name":"transform_ids","in":"query"},{"description":"List of project ids to retrieve transformations from.","required":false,"schema":{"items":{"type":"string"},"type":"array","title":"Proj Ids","description":"List of project ids to retrieve transformations from."},"name":"proj_ids","in":"query"},{"description":"Boolean flag to include transform params, which includes the operations.","required":false,"schema":{"type":"boolean","title":"Include Transform Params","description":"Boolean flag to include transform params, which includes the operations.","default":true},"name":"include_transform_params","in":"query"},{"required":false,"schema":{"type":"integer","exclusiveMinimum":true,"title":"Limit","default":20,"minimum":0.0},"name":"limit","in":"query"},{"required":false,"schema":{"type":"integer","minimum":0.0,"title":"Offset","default":0},"name":"offset","in":"query"},{"required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/OrderByEnum"}],"default":"updated_at"},"name":"order_by","in":"query"},{"required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/SortOrderEnum"}],"default":"desc"},"name":"order","in":"query"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"anyOf":[{"$ref":"#/components/schemas/GetTransformsWithTransformParamsResponse"},{"$ref":"#/components/schemas/GetTransformsResponse"}],"title":"Response Get Transforms V1 Transforms Get"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"transformation_not_found":{"summary":"transformation_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_not_found","message":"Transformation not found with id(s): $transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"customer_not_found":{"summary":"customer_not_found","value":{"request_id":"$request_id","error":{"code":"customer_not_found","message":"Customer for transformation not found with id(s): $cust_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found":{"summary":"transformation_row_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found","message":"Transformation row not found with id(s): $transform_row_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found_for_asset":{"summary":"transformation_row_not_found_for_asset","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found_for_asset","message":"Transformation row not found with asset id(s): $transform_asset_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"no_asset_type_ops_found":{"summary":"no_asset_type_ops_found","value":{"request_id":"$request_id","error":{"code":"no_asset_type_ops_found","message":"At least one asset-type column is required to create a new transformation.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"not_all_column_column_ops":{"summary":"not_all_column_column_ops","value":{"request_id":"$request_id","error":{"code":"not_all_column_column_ops","message":"The following non-asset, non-manual operations don't reference other columns: $op_ids","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_not_completed":{"summary":"transformation_not_completed","value":{"request_id":"$request_id","error":{"code":"transformation_not_completed","message":"Transformation is not yet completed","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"no_transform_operations":{"summary":"no_transform_operations","value":{"request_id":"$request_id","error":{"code":"no_transform_operations","message":"No transformation operations found","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"failed_to_create_transform":{"summary":"failed_to_create_transform","value":{"request_id":"$request_id","error":{"code":"failed_to_create_transform","message":"Failed to create Transform","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_run_failed_to_start":{"summary":"transform_run_failed_to_start","value":{"request_id":"$request_id","error":{"code":"transform_run_failed_to_start","message":"Transformation run failed to start","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"rows_dont_belong_to_transform":{"summary":"rows_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"rows_dont_belong_to_transform","message":"The row ids $row_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/transforms/{transform_id}":{"patch":{"tags":["transforms","public"],"summary":"Refresh Transform","description":"Refreshes an existing transform by re-running operations\non rows that need updating.","operationId":"refresh_transform_v1_transforms__transform_id__patch","parameters":[{"required":true,"schema":{"type":"string","title":"Transform Id"},"name":"transform_id","in":"path"},{"description":"List of asset ids to refresh. Don't provide if providing row_ids","required":false,"schema":{"items":{"type":"string"},"type":"array","title":"Asset Ids","description":"List of asset ids to refresh. Don't provide if providing row_ids"},"name":"asset_ids","in":"query"},{"description":"List of row ids to refresh. Don't provide if providing asset_ids","required":false,"schema":{"items":{"type":"string"},"type":"array","title":"Row Ids","description":"List of row ids to refresh. Don't provide if providing asset_ids"},"name":"row_ids","in":"query"},{"required":false,"schema":{"type":"boolean","title":"Include Reference","default":false},"name":"include_reference","in":"query"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ReRunTransformResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"no_rows_found":{"summary":"no_rows_found","value":{"request_id":"$request_id","error":{"code":"no_rows_found","message":"No rows found for the requested row_id or transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"both_asset_ids_and_result_ids":{"summary":"both_asset_ids_and_result_ids","value":{"request_id":"$request_id","error":{"code":"both_asset_ids_and_result_ids","message":"Cannot provide both asset_ids and result_ids, only one","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"asset_result_length_mismatch":{"summary":"asset_result_length_mismatch","value":{"request_id":"$request_id","error":{"code":"asset_result_length_mismatch","message":"Length of existing_asset_ids_filtered: $existing_asset_ids_filtered_count does not match length of result_ids_existing: $existing_result_ids_countor length of assets_existing: $existing_assets_count","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/transforms/{transform_id}/autoschema":{"get":{"tags":["transforms","public"],"summary":"Get Autoschema","operationId":"Get_autoschema_v1_transforms__transform_id__autoschema_get","parameters":[{"description":"The transform_id to get the autoschema for","required":true,"schema":{"type":"string","title":"Transform Id","description":"The transform_id to get the autoschema for"},"name":"transform_id","in":"path"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AutoschemaResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"transformation_not_found":{"summary":"transformation_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_not_found","message":"Transformation not found with id(s): $transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"customer_not_found":{"summary":"customer_not_found","value":{"request_id":"$request_id","error":{"code":"customer_not_found","message":"Customer for transformation not found with id(s): $cust_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found":{"summary":"transformation_row_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found","message":"Transformation row not found with id(s): $transform_row_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found_for_asset":{"summary":"transformation_row_not_found_for_asset","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found_for_asset","message":"Transformation row not found with asset id(s): $transform_asset_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"no_asset_type_ops_found":{"summary":"no_asset_type_ops_found","value":{"request_id":"$request_id","error":{"code":"no_asset_type_ops_found","message":"At least one asset-type column is required to create a new transformation.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"not_all_column_column_ops":{"summary":"not_all_column_column_ops","value":{"request_id":"$request_id","error":{"code":"not_all_column_column_ops","message":"The following non-asset, non-manual operations don't reference other columns: $op_ids","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_not_completed":{"summary":"transformation_not_completed","value":{"request_id":"$request_id","error":{"code":"transformation_not_completed","message":"Transformation is not yet completed","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"no_transform_operations":{"summary":"no_transform_operations","value":{"request_id":"$request_id","error":{"code":"no_transform_operations","message":"No transformation operations found","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"failed_to_create_transform":{"summary":"failed_to_create_transform","value":{"request_id":"$request_id","error":{"code":"failed_to_create_transform","message":"Failed to create Transform","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_run_failed_to_start":{"summary":"transform_run_failed_to_start","value":{"request_id":"$request_id","error":{"code":"transform_run_failed_to_start","message":"Transformation run failed to start","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"rows_dont_belong_to_transform":{"summary":"rows_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"rows_dont_belong_to_transform","message":"The row ids $row_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/transforms/{transform_id}/results":{"post":{"tags":["transforms","public"],"summary":"Get Transform Results","description":"Retrieve the results of a transformation for a given transform_id and customer.\n\nParameters:\n- transform_id (str): The ID of the transformation.\n- asset_ids (List[str], optional): List of asset IDs to filter results by.\n- row_ids (List[str], optional): List of row IDs to filter results by.\n- result_id (str, optional): Result ID to retrieve.\n- request_body (GetTransformResultsRequest, optional): Additional filters and parameters.\n\nReturns:\n- Dict[List]: A list of rows representing the transformation results.\n\nRaises:\n- HTTPException: If the user does not have access to the transformation.","operationId":"get_transform_results_v1_transforms__transform_id__results_post","parameters":[{"description":"Transformation ID for the transformation to retrieve.","required":true,"schema":{"type":"string","title":"Transform Id","description":"Transformation ID for the transformation to retrieve."},"name":"transform_id","in":"path"},{"description":"Result ID to retrieve. Will be deprecated in Jan 2025.","required":false,"schema":{"type":"string","title":"Result Id","description":"Result ID to retrieve. Will be deprecated in Jan 2025."},"name":"result_id","in":"query"},{"required":false,"schema":{"type":"integer","exclusiveMinimum":true,"title":"Limit","default":50,"minimum":0.0},"name":"limit","in":"query"},{"required":false,"schema":{"type":"integer","minimum":0.0,"title":"Offset","default":0},"name":"offset","in":"query"},{"required":false,"schema":{"type":"string","title":"Order By","default":"increment_id"},"name":"order_by","in":"query"},{"required":false,"schema":{"allOf":[{"$ref":"#/components/schemas/SortOrderEnum"}],"default":"asc"},"name":"order","in":"query"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetTransformResultsRequest"}}}},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"anyOf":[{"$ref":"#/components/schemas/GetTransformResultsResponse"},{"$ref":"#/components/schemas/GetTransformResultsResponseV2"}],"title":"Response Get Transform Results V1 Transforms  Transform Id  Results Post"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"transformation_not_found":{"summary":"transformation_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_not_found","message":"Transformation not found with id(s): $transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"customer_not_found":{"summary":"customer_not_found","value":{"request_id":"$request_id","error":{"code":"customer_not_found","message":"Customer for transformation not found with id(s): $cust_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found":{"summary":"transformation_row_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found","message":"Transformation row not found with id(s): $transform_row_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found_for_asset":{"summary":"transformation_row_not_found_for_asset","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found_for_asset","message":"Transformation row not found with asset id(s): $transform_asset_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"no_asset_type_ops_found":{"summary":"no_asset_type_ops_found","value":{"request_id":"$request_id","error":{"code":"no_asset_type_ops_found","message":"At least one asset-type column is required to create a new transformation.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"not_all_column_column_ops":{"summary":"not_all_column_column_ops","value":{"request_id":"$request_id","error":{"code":"not_all_column_column_ops","message":"The following non-asset, non-manual operations don't reference other columns: $op_ids","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_not_completed":{"summary":"transformation_not_completed","value":{"request_id":"$request_id","error":{"code":"transformation_not_completed","message":"Transformation is not yet completed","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"no_transform_operations":{"summary":"no_transform_operations","value":{"request_id":"$request_id","error":{"code":"no_transform_operations","message":"No transformation operations found","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"failed_to_create_transform":{"summary":"failed_to_create_transform","value":{"request_id":"$request_id","error":{"code":"failed_to_create_transform","message":"Failed to create Transform","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_run_failed_to_start":{"summary":"transform_run_failed_to_start","value":{"request_id":"$request_id","error":{"code":"transform_run_failed_to_start","message":"Transformation run failed to start","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"rows_dont_belong_to_transform":{"summary":"rows_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"rows_dont_belong_to_transform","message":"The row ids $row_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]},{"APIKeyHeader":[]}]}},"/v1/transforms/create":{"post":{"tags":["transforms","public"],"summary":"Create Transform","description":"Run the transformation defined in transformation params for all the assets in the project\n\nArgs:\n    transform_id (str): The ID of the transformation to run.\n\nReturns:\n    {\"message\": \"Transformation initiated\", \"transform_id\": transform_id}","operationId":"create_transform_v1_transforms_create_post","parameters":[{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TransformationRequest"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateTransformResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"transformation_not_found":{"summary":"transformation_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_not_found","message":"Transformation not found with id(s): $transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"customer_not_found":{"summary":"customer_not_found","value":{"request_id":"$request_id","error":{"code":"customer_not_found","message":"Customer for transformation not found with id(s): $cust_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found":{"summary":"transformation_row_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found","message":"Transformation row not found with id(s): $transform_row_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found_for_asset":{"summary":"transformation_row_not_found_for_asset","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found_for_asset","message":"Transformation row not found with asset id(s): $transform_asset_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"no_asset_type_ops_found":{"summary":"no_asset_type_ops_found","value":{"request_id":"$request_id","error":{"code":"no_asset_type_ops_found","message":"At least one asset-type column is required to create a new transformation.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"not_all_column_column_ops":{"summary":"not_all_column_column_ops","value":{"request_id":"$request_id","error":{"code":"not_all_column_column_ops","message":"The following non-asset, non-manual operations don't reference other columns: $op_ids","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_not_completed":{"summary":"transformation_not_completed","value":{"request_id":"$request_id","error":{"code":"transformation_not_completed","message":"Transformation is not yet completed","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"no_transform_operations":{"summary":"no_transform_operations","value":{"request_id":"$request_id","error":{"code":"no_transform_operations","message":"No transformation operations found","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"failed_to_create_transform":{"summary":"failed_to_create_transform","value":{"request_id":"$request_id","error":{"code":"failed_to_create_transform","message":"Failed to create Transform","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_run_failed_to_start":{"summary":"transform_run_failed_to_start","value":{"request_id":"$request_id","error":{"code":"transform_run_failed_to_start","message":"Transformation run failed to start","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"rows_dont_belong_to_transform":{"summary":"rows_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"rows_dont_belong_to_transform","message":"The row ids $row_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]},{"APIKeyHeader":[]}]}},"/v1/transforms/{transform_id}/rows":{"post":{"tags":["transforms","public"],"summary":"Add Rows","operationId":"add_rows_v1_transforms__transform_id__rows_post","parameters":[{"required":true,"schema":{"type":"string","title":"Transform Id"},"name":"transform_id","in":"path"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddRowsRequest"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddRowResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"transformation_not_found":{"summary":"transformation_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_not_found","message":"Transformation not found with id(s): $transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"customer_not_found":{"summary":"customer_not_found","value":{"request_id":"$request_id","error":{"code":"customer_not_found","message":"Customer for transformation not found with id(s): $cust_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found":{"summary":"transformation_row_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found","message":"Transformation row not found with id(s): $transform_row_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found_for_asset":{"summary":"transformation_row_not_found_for_asset","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found_for_asset","message":"Transformation row not found with asset id(s): $transform_asset_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"no_asset_type_ops_found":{"summary":"no_asset_type_ops_found","value":{"request_id":"$request_id","error":{"code":"no_asset_type_ops_found","message":"At least one asset-type column is required to create a new transformation.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"not_all_column_column_ops":{"summary":"not_all_column_column_ops","value":{"request_id":"$request_id","error":{"code":"not_all_column_column_ops","message":"The following non-asset, non-manual operations don't reference other columns: $op_ids","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_not_completed":{"summary":"transformation_not_completed","value":{"request_id":"$request_id","error":{"code":"transformation_not_completed","message":"Transformation is not yet completed","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"no_transform_operations":{"summary":"no_transform_operations","value":{"request_id":"$request_id","error":{"code":"no_transform_operations","message":"No transformation operations found","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"failed_to_create_transform":{"summary":"failed_to_create_transform","value":{"request_id":"$request_id","error":{"code":"failed_to_create_transform","message":"Failed to create Transform","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_run_failed_to_start":{"summary":"transform_run_failed_to_start","value":{"request_id":"$request_id","error":{"code":"transform_run_failed_to_start","message":"Transformation run failed to start","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"rows_dont_belong_to_transform":{"summary":"rows_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"rows_dont_belong_to_transform","message":"The row ids $row_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]},"patch":{"tags":["transforms","public"],"summary":"Patch Rows","operationId":"patch_rows_v1_transforms__transform_id__rows_patch","parameters":[{"required":true,"schema":{"type":"string","title":"Transform Id"},"name":"transform_id","in":"path"},{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpsertRowsRequest"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddRowResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"transformation_not_found":{"summary":"transformation_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_not_found","message":"Transformation not found with id(s): $transform_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"customer_not_found":{"summary":"customer_not_found","value":{"request_id":"$request_id","error":{"code":"customer_not_found","message":"Customer for transformation not found with id(s): $cust_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found":{"summary":"transformation_row_not_found","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found","message":"Transformation row not found with id(s): $transform_row_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_row_not_found_for_asset":{"summary":"transformation_row_not_found_for_asset","value":{"request_id":"$request_id","error":{"code":"transformation_row_not_found_for_asset","message":"Transformation row not found with asset id(s): $transform_asset_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"no_asset_type_ops_found":{"summary":"no_asset_type_ops_found","value":{"request_id":"$request_id","error":{"code":"no_asset_type_ops_found","message":"At least one asset-type column is required to create a new transformation.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"not_all_column_column_ops":{"summary":"not_all_column_column_ops","value":{"request_id":"$request_id","error":{"code":"not_all_column_column_ops","message":"The following non-asset, non-manual operations don't reference other columns: $op_ids","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transformation_not_completed":{"summary":"transformation_not_completed","value":{"request_id":"$request_id","error":{"code":"transformation_not_completed","message":"Transformation is not yet completed","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"no_transform_operations":{"summary":"no_transform_operations","value":{"request_id":"$request_id","error":{"code":"no_transform_operations","message":"No transformation operations found","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"failed_to_create_transform":{"summary":"failed_to_create_transform","value":{"request_id":"$request_id","error":{"code":"failed_to_create_transform","message":"Failed to create Transform","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"transform_run_failed_to_start":{"summary":"transform_run_failed_to_start","value":{"request_id":"$request_id","error":{"code":"transform_run_failed_to_start","message":"Transformation run failed to start","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"rows_dont_belong_to_transform":{"summary":"rows_dont_belong_to_transform","value":{"request_id":"$request_id","error":{"code":"rows_dont_belong_to_transform","message":"The row ids $row_ids do not belong to the transformation with id $transform_id","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/events/subscriptions/actions/bulk":{"post":{"tags":["events","public"],"summary":"Create Event Subscriptions With Actions","operationId":"create_event_subscriptions_with_actions_v1_events_subscriptions_actions_bulk_post","parameters":[{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateEventSubscriptionsWithActionsRequest"}}},"required":true},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateEventSubscriptionsWithActionsResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"event_subscription_not_found":{"summary":"event_subscription_not_found","value":{"request_id":"$request_id","error":{"code":"event_subscription_not_found","message":"Event subscription not found with id(s): $event_subscription_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"action_id_not_found":{"summary":"action_id_not_found","value":{"request_id":"$request_id","error":{"code":"action_id_not_found","message":"Action id not found with id(s): $action_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}},"job_not_found":{"summary":"job_not_found","value":{"request_id":"$request_id","error":{"code":"job_not_found","message":"Job not found with id(s): $job_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","message":"Request timed out waiting for $event","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"examples":{"unprocessable_entity":{"summary":"unprocessable_entity","value":{"request_id":"$request_id","error":{"code":"unprocessable_entity","message":"Unprocessable data provided","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"429":{"description":"Too Many Requests","content":{"application/json":{"examples":{"rate_limit_exceeded":{"summary":"rate_limit_exceeded","value":{"request_id":"$request_id","error":{"code":"rate_limit_exceeded","message":"Rate limit exceeded. Please try again later. $limit_message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"400":{"description":"Bad Request","content":{"application/json":{"examples":{"bad_request":{"summary":"bad_request","value":{"request_id":"$request_id","error":{"code":"bad_request","message":"$message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}}},"security":[{"APIKeyHeader":[]}]}},"/v1/webhook":{"get":{"tags":["webhook","public"],"summary":"Get All Webhooks","operationId":"get_all_webhooks_v1_webhook_get","parameters":[{"description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended).","required":false,"schema":{"type":"string","title":"Api-Version","description":"Pass in an API version to guarantee a consistent response format.\n\nThe latest version should be used for all new API calls. Existing API calls should be updated to the latest version when possible.\n\n**Valid versions:**\n\n- Latest API version (recommended): `2025-03`\n\n- Previous API version (maintenance mode): `2025-02`\n\nIf no API version header is included, the response format is considered unstable and could change without notice (not recommended)."},"example":"2025-03","name":"API-Version","in":"header"}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetAllWebhooksResponse"}}}},"404":{"description":"Not Found","content":{"application/json":{"examples":{"webhook_not_found":{"summary":"webhook_not_found","value":{"request_id":"$request_id","error":{"code":"webhook_not_found","message":"Webhook not found with id(s): $webhook_id.","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"examples":{"internal_server_error":{"summary":"internal_server_error","value":{"request_id":"$request_id","error":{"code":"internal_server_error","message":"Internal server error occurred. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"401":{"description":"Unauthorized","content":{"application/json":{"examples":{"unauthorized":{"summary":"unauthorized","value":{"request_id":"$request_id","error":{"code":"unauthorized","message":"Unauthorized access. $message","attributes":{"$dynamic_error_key":"$dynamic_error_value"}}}}}}}},"408":{"description":"Request Timeout","content":{"application/json":{"examples":{"timeout":{"summary":"timeout","value":{"request_id":"$request_id","error":{"code":"timeout","
[...]
